package com.hzya.frame.plugin.dgx.oa.service.impl;


import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.dgx.oa.dao.IPaymentOrderDao;
import com.hzya.frame.plugin.dgx.oa.entity.PaymentOrderEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.CfsLogEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.OAWorkflowEventDataEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.service.impl.CfsLogServiceImpl;
import com.hzya.frame.plugin.dgx.oa.service.IPaymentOrderService;
import com.hzya.frame.plugin.dgx.u9c.service.impl.AcquireTokenServiceImpl;
import com.hzya.frame.web.entity.BaseResult;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service(value = "PaymentOrderServiceImpl")
public class PaymentOrderServiceImpl extends BaseService implements IPaymentOrderService {

    @Autowired
    private CfsLogServiceImpl cfsLogService;

    private IPaymentOrderDao paymentOrderDao;

    @Autowired
    public void setPaymentOrderDao(IPaymentOrderDao dao) {
        this.paymentOrderDao = dao;
        this.dao=dao;
    }

    private  static String URLTEST="http://122.224.56.190:8082";
    @Autowired
    private AcquireTokenServiceImpl acquireTokenService;

    //将付款单推送U9C
    @Override
    public Object queryPaymentOrderToU9C(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        String formApp = jsonObject.getString("formApp");
        String id = jsonObject.getString("id");
        String dataSourceCode = jsonObject.getString("dataSourceCode");
        logger.info("====付款单得formApp为:{}=====",formApp);
        //付款单得formAppid
        if(!checkStr(formApp) && formApp.equals("-4485599744122928343")){
            return BaseResult.getFailureMessageEntity("formApp不能为空");
        }
        jsonObject.remove("formApp");
        jsonObject.remove("id");
        jsonObject.remove("grpDataSourceCode");
        try {
            String token = acquireTokenService.getToken();
            logger.info("获取得德广信U9Ctoken为：{}",token);
            if(StrUtil.isNotEmpty(token)){
                String params = jsonObject.toJSONString();
                JSONObject jsonObject1 = JSONObject.parseObject(params);
                JSONArray jsonArray1 = new JSONArray();
                jsonArray1.add(jsonObject1);
                String jsonStr = String.valueOf(jsonArray1);
                //调用U9C付款单新增接口
                logger.info("====OA付款单传递德广信U9C得请求参数为:{}======",jsonStr);
                String body = HttpRequest.post(URLTEST + "/U9C/webapi/PayBill/Create").header("token", token).header("content-type", "application/json").body(jsonStr).execute().body();
                logger.info("====OA付款单传递德广信U9C得返回参数为:{}======",body);
                JSONObject jsonBody = JSONObject.parseObject(body);
                if(jsonBody.getString("Success").equals("true")){
                    JSONArray jsonArray = jsonBody.getJSONArray("Data");
                    if(CollectionUtils.isNotEmpty(jsonArray)){
                        JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArray.get(0)));
                        String mCode = jsonData.getString("Code");
                        logger.info("=====德广信U9C付款单新增返回得付款订单号为:{}===",mCode);
                        if(StrUtil.isNotEmpty(mCode)){
                           /* PaymentOrderEntity paymentOrderEntity=new PaymentOrderEntity();
                            paymentOrderEntity.setDocNo(mCode);
                            paymentOrderEntity.setId(id);
                            paymentOrderEntity.setDataSourceCode(dataSourceCode);
                            paymentOrderDao.updatePaymentOrderDocNo(paymentOrderEntity);
                            OAWorkflowEventDataEntity oaWorkflowEventDataEntity=new OAWorkflowEventDataEntity();
                            oaWorkflowEventDataEntity.setId(id);
                            oaWorkflowEventDataEntity.setFormApp(formApp);
                            oaWorkflowEventDataEntity.setBusinessDataStr(paymentOrderEntity.getDocNo());
                            cfsLogService.importCfsLog(new CfsLogEntity("销售订单","formmain_0666",oaWorkflowEventDataEntity,body));*/
                            return BaseResult.getSuccessMessageEntity("付款单推送成功",mCode);
                        }else{
                            return BaseResult.getFailureMessageEntity("付款单推送失败",jsonBody.getString("ResMsg"));
                        }
                    }else{
                        return BaseResult.getFailureMessageEntity("付款单推送失败",jsonBody.getString("ResMsg"));
                    }
                }else{
                    return BaseResult.getFailureMessageEntity("付款单推送失败",jsonBody.getString("ResMsg"));
                }
            }
        }catch (Exception e){
            logger.info("========OA付款单推送U9C失败:{}=========",e.getMessage());
        }
        return null;
    }

    @Override
    public Integer updatePaymentOrderStatus(JSONObject json) {
        return null;
    }
}
