package com.hzya.frame.plugin.dgx.oa.service.impl;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.dgx.oa.dao.ISalesOrderDao;
import com.hzya.frame.plugin.dgx.oa.entity.SalesOrderEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.CfsLogEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.OAWorkflowEventDataEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.service.impl.CfsLogServiceImpl;
import com.hzya.frame.plugin.dgx.oa.service.ISalesOrderService;
import com.hzya.frame.plugin.dgx.u9c.service.impl.AcquireTokenServiceImpl;
import com.hzya.frame.sysnew.application.database.dao.ISysApplicationDatabaseDao;
import com.hzya.frame.web.entity.BaseResult;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service(value = "SalesOrderServiceImpl")
public class SalesOrderServiceImpl extends BaseService<SalesOrderEntity,String> implements ISalesOrderService {

    private ISalesOrderDao salesOrderDao;

    @Autowired
    public void setSalesOrderDao(ISalesOrderDao dao) {
        this.salesOrderDao = dao;
        this.dao=dao;
    }


    private  static String URLTEST="http://122.224.56.190:8082";

    @Autowired
    private ISysApplicationDatabaseDao sysApplicationDatabaseDao;

    @Autowired
    private AcquireTokenServiceImpl acquireTokenService;

    @Autowired
    private CfsLogServiceImpl cfsLogService;

    //查询OA销售订单传递U9C
    @Override
    public Object querySalesOrderToU9C(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        String formApp = jsonObject.getString("formApp");
        String id = jsonObject.getString("id");
        String dataSourceCode = jsonObject.getString("dataSourceCode");
        logger.info("====销售订单得formApp为:{}=====",formApp);
        //销售订单得formAppid
        if(!checkStr(formApp) && formApp.equals("-4485599744122928342")){
            return BaseResult.getFailureMessageEntity("formApp不能为空");
        }
        jsonObject.remove("formApp");
        jsonObject.remove("id");
        jsonObject.remove("grpDataSourceCode");
        try {
            String token = acquireTokenService.getToken();
            logger.info("获取得德广信U9Ctoken为：{}",token);
            if(StrUtil.isNotEmpty(token)){
                String params = jsonObject.toJSONString();
                JSONObject jsonObject1 = JSONObject.parseObject(params);
                JSONArray jsonArray1 = new JSONArray();
                jsonArray1.add(jsonObject1);
                String jsonStr = String.valueOf(jsonArray1);
                //调用U9C销售订单新增接口
                logger.info("====OA销售订单传递德广信U9C得请求参数为:{}======",jsonStr);
                String body = HttpRequest.post(URLTEST + "/U9C/webapi/SO/Create").header("token", token).header("content-type", "application/json").body(jsonStr).execute().body();
                logger.info("====OA销售订单传递德广信U9C得返回参数为:{}======",body);
                JSONObject jsonBody = JSONObject.parseObject(body);
                if(jsonBody.getString("Success").equals("true")){
                    JSONArray jsonArray = jsonBody.getJSONArray("Data");
                    if(CollectionUtils.isNotEmpty(jsonArray)) {
                        JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArray.get(0)));
                        String mCode = jsonData.getString("m_code");
                        logger.info("=====德广信U9C销售订单新增返回得销售订单号为:{}===", mCode);
                        if (StrUtil.isNotEmpty(mCode)) {
                            /*SalesOrderEntity salesOrderEntity=new SalesOrderEntity();
                            salesOrderEntity.setDocNo(mCode);
                            salesOrderEntity.setId(id);
                            salesOrderEntity.setDataSourceCode(dataSourceCode);
                            salesOrderDao.updateSalesOrderDocNo(salesOrderEntity);
                            OAWorkflowEventDataEntity oaWorkflowEventDataEntity = new OAWorkflowEventDataEntity();
                            oaWorkflowEventDataEntity.setId(id);
                            oaWorkflowEventDataEntity.setFormApp(formApp);
                            oaWorkflowEventDataEntity.setBusinessDataStr(salesOrderEntity.getDocNo());
                            cfsLogService.importCfsLog(new CfsLogEntity("销售订单", "formmain_0666", oaWorkflowEventDataEntity, body));*/
                            return BaseResult.getSuccessMessageEntity("销售订单推送成功", mCode);
                        }else{
                            return BaseResult.getFailureMessageEntity("销售订单推送失败",jsonBody.getString("ResMsg"));
                        }
                    }else{
                        return BaseResult.getFailureMessageEntity("销售订单推送失败",jsonBody.getString("ResMsg"));
                    }
                }
                else{
                    return BaseResult.getFailureMessageEntity("销售订单推送失败",jsonBody.getString("ResMsg"));
                }
            }
        }catch (Exception e){
            logger.info("========OA销售订单推送U9C失败:{}=========",e.getMessage());
        }
        return null;
    }

    //将已审核得销售订单传递U9C
    @Override
    public Object querySalesOrderToU9CByAudit(JSONObject json) {
        return null;
    }


    //更新推送状态
    @Override
    public Integer updateSalesOrderStatus(JSONObject json) {
        return null;
    }
}
